import 'package:agschat/src/helper/custom_image_picker.dart';
import 'package:agschat/src/helper/custom_styles.dart';
import 'package:agschat/src/view/widgets/comman.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';

class ProfileView extends StatefulWidget {
  const ProfileView({Key? key}) : super(key: key);

  @override
  State<ProfileView> createState() => _ProfileViewState();
}

class _ProfileViewState extends State<ProfileView> {
  TextEditingController txtUserName = TextEditingController();

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      backgroundColor: Colors.white,
      bottomNavigationBar: SafeArea(
        child: GestureDetector(
          onTap: () {
            if (txtUserName.text.isNotEmpty) {
              print("done");
            } else {}
          },
          child: Container(
            height: 50,
            margin: const EdgeInsets.only(top: 16, left: 20, right: 20),
            decoration: BoxDecoration(
              borderRadius: BorderRadius.circular(8.0),
              color: Colors.blue,
            ),
            child: Center(
              child: Text(
                "Save",
                style: CustomTextStyles.semiBold(
                    fontSize: 18.0, fontColor: Colors.white),
              ),
            ),
          ),
        ),
      ),
      body: SafeArea(
        child: Column(
          children: [
            appBar(),
            Container(
              padding: const EdgeInsets.only(left: 20, right: 20),
              width: Get.width,
              color: Colors.white,
              child: Column(
                children: [
                  const SizedBox(
                    height: 24,
                  ),
                  Stack(
                    alignment: AlignmentDirectional.center,
                    children: [
                      GestureDetector(
                          onTap: () async {
                            var image = await CustomFilePicker.imagePicker(
                                fromCamera: false);
                          },
                          child: Common.profileNetworkImage(
                            borderRadius: 200.0,
                            height: 200.0,
                            width: 200.0,
                            imageUrl: "",
                          )),
                      const Icon(
                        Icons.camera_alt_outlined,
                        color: Colors.white,
                        size: 30.0,
                      )
                    ],
                  ),
                  const SizedBox(
                    height: 32,
                  ),
                  TextField(
                    controller: txtUserName,
                    decoration: InputDecoration(
                      hintText: "Enter User Name",
                      hintStyle: CustomTextStyles.medium(
                          fontSize: 14.0, fontColor: Colors.black38),
                      filled: true,
                      fillColor: const Color(0xffEEEEEF),
                      border: searchCommonBorderStyle,
                      enabledBorder: searchCommonBorderStyle,
                      disabledBorder: searchCommonBorderStyle,
                      focusedBorder: searchCommonBorderStyle,
                      focusedErrorBorder: searchCommonBorderStyle,
                      errorBorder: searchCommonBorderStyle,
                      contentPadding: const EdgeInsets.only(left: 6, right: 6),
                    ),
                  ),
                  const SizedBox(
                    height: 8,
                  ),
                  Text(
                    "This is not your username or pin. This name will be visible to your chat contact.",
                    style: CustomTextStyles.normal(
                        fontSize: 14.0, fontColor: Colors.black54),
                  ),
                  const SizedBox(
                    height: 16,
                  ),
                ],
              ),
            ),
            const SizedBox(
              height: 10,
            ),
          ],
        ),
      ),
    );
  }

  var searchCommonBorderStyle = const OutlineInputBorder(
    borderSide: BorderSide(
      color: Color(0xffE6E6E6),
    ),
  );

  Widget appBar() {
    return Container(
      color: const Color(0xffE5E5EA),
      child: Row(
        children: [
          IconButton(
              onPressed: () {
                Get.back();
              },
              icon: const Icon(
                Icons.arrow_back_outlined,
                size: 25.0,
              )),
          const SizedBox(
            width: 8,
          ),
          Text(
            "Profile",
            style: CustomTextStyles.medium(
                fontSize: 18.0, fontColor: Colors.black),
          ),
        ],
      ),
    );
  }
}
